const observer = new MutationObserver(() => {
    insertImageAfterNumbers();
});

function insertImageAfterNumbers() {
    const elements = document.querySelectorAll('p, h1, h2, h3, h4');

    elements.forEach(element => {
        if (element.childNodes.length === 0) return;

        element.childNodes.forEach(node => {
            if (node.nodeType === Node.TEXT_NODE) {
                const text = node.textContent;
                // Updated regex to capture numbers at the end of a string, with or without punctuation
                const regex = /(\d{4,})([.,;!?]?)\s*$/g;

                if (regex.test(text)) {
                    const newHtml = text.replace(regex, (match, number, punctuation) => {
                        console.log(`Found number: ${number}`);
                        return parseInt(number) >= 9000 
                            ? `${number} <img src="${chrome.runtime.getURL('vegeta.png')}" style="height: 30px; vertical-align: middle;" />${punctuation} `
                            : match;
                    });

                    // Create a new span element and set its HTML
                    const span = document.createElement('span');
                    span.innerHTML = newHtml;

                    // Replace the old text node with the new span
                    element.replaceChild(span, node);
                }
            }
        });
    });
}

// Start observing the body for changes
observer.observe(document.body, { childList: true, subtree: true });

// Initial call to handle existing content
insertImageAfterNumbers();
